require 'package'
class Re6stnet < Package
  description 'Resilient, Scalable, IPv6 Network'
  homepage 'https://re6st.nexedi.com/'
  version '0.530'
  source_url 'https://lab.nexedi.com/nexedi/chromebrew-buildout-re6st/repository/archive.tar.bz2?ref=e6574c96b236cfed2d8604349499c39baf5cba3a'
  source_sha256 '0a2c1a1faff4d6d99401682bab6d70ad7f4f74aad78499d254fb47470df5c898'

  binary_url ({
    x86_64: 'https://softinst105421.host.vifib.net/public/re6stnet-0.530-chromeos-x86_64.tar.xz',
  })
  binary_sha256 ({
    x86_64: '4a55403feb3420ccb37f798486a388a3cfdf3cf7e51b84ff89fc51680e280337',
  })

  depends_on 'python27' => :build
  depends_on 'filecmd' => :build
  depends_on 'libiconv' => :build
  depends_on 'glibc'

  @re6st_dir = "#{CREW_PREFIX}/opt/re6st"

  def self.build
    system "mkdir -p #{@re6st_dir}/bin/ #{@re6st_dir}/tmp-networkcached/bin"
    system "cp buildout.cfg #{@re6st_dir}"
    system "cp bin/* #{@re6st_dir}/bin/"
    system "gcc shill_wrapper.c -o #{@re6st_dir}/bin/shill_wrapper -ldl -Wall -fPIC -pie"
    system "cp bin/bootstrap #{@re6st_dir}/tmp-networkcached/bin/"
    system "cp networkcached.cfg #{@re6st_dir}/tmp-networkcached/buildout.cfg"
    system "cd #{@re6st_dir}/tmp-networkcached && ./bin/bootstrap && MAKEFLAGS=-j ./bin/buildout"
    system "cd #{@re6st_dir} && MAKEFLAGS=-j SSL_CERT_DIR=/etc/ssl/certs tmp-networkcached/bin/buildout"
  end

  def self.install
    system "mkdir -p #{CREW_DEST_PREFIX}/opt/"
    system "cp -r #{@re6st_dir} #{CREW_DEST_DIR}#{@re6st_dir}"
    system "rm -rf #{CREW_DEST_DIR}#{@re6st_dir}/download-cache"
  end

  def self.postinstall
    system "ln -fs #{@re6st_dir}/bin/grandenet #{CREW_PREFIX}/sbin/grandenet"
    system "ln -fs #{@re6st_dir}/bin/shill.sh #{CREW_PREFIX}/sbin/shill.sh"
    system "ln -fs #{@re6st_dir}/bin/shill_wrapper #{CREW_PREFIX}/sbin/shill_wrapper"
    system "ln -fs #{@re6st_dir}/bin/re6stnet #{CREW_PREFIX}/sbin/re6stnet"
    system "ln -fs #{@re6st_dir}/bin/re6st-conf #{CREW_PREFIX}/bin/re6st-conf"
    system "ln -fs #{@re6st_dir}/bin/re6st-registry #{CREW_PREFIX}/bin/re6st-registry"
    puts "To initiate re6stnet, run #{CREW_PREFIX}/sbin/grandenet"
  end
end
